// FullAccess
resource "azurerm_role_definition" "customer_insights_fullaccess_definition" {
  name              = "customer-insights-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.CustomerInsights/register/action",
      "Microsoft.CustomerInsights/unregister/action",
      "Microsoft.CustomerInsights/operations/read",
      "Microsoft.CustomerInsights/hubs/read",
      "Microsoft.CustomerInsights/hubs/write",
      "Microsoft.CustomerInsights/hubs/delete",
      "Microsoft.CustomerInsights/hubs/suggesttypeschema/action",
      "Microsoft.CustomerInsights/hubs/crmmetadata/action",
      "Microsoft.CustomerInsights/hubs/adobemetadata/action",
      "Microsoft.CustomerInsights/hubs/salesforcemetadata/action",
      "Microsoft.CustomerInsights/hubs/msemetadata/action",
      "Microsoft.CustomerInsights/hubs/operationresults/read",
      "Microsoft.CustomerInsights/hubs/getbillinghistory/read",
      "Microsoft.CustomerInsights/hubs/getbillingcredits/read",
      "Microsoft.CustomerInsights/hubs/tenantmanagement/read",
      "Microsoft.CustomerInsights/hubs/views/read",
      "Microsoft.CustomerInsights/hubs/views/write",
      "Microsoft.CustomerInsights/hubs/views/delete",
      "Microsoft.CustomerInsights/hubs/images/read",
      "Microsoft.CustomerInsights/hubs/images/write",
      "Microsoft.CustomerInsights/hubs/images/delete",
      "Microsoft.CustomerInsights/hubs/widgettypes/read",
      "Microsoft.CustomerInsights/hubs/crmmetadata/read",
      "Microsoft.CustomerInsights/hubs/adobemetadata/read",
      "Microsoft.CustomerInsights/hubs/salesforcemetadata/read",
      "Microsoft.CustomerInsights/hubs/msemetadata/read",
      "Microsoft.CustomerInsights/hubs/connectors/read",
      "Microsoft.CustomerInsights/hubs/connectors/write",
      "Microsoft.CustomerInsights/hubs/connectors/delete",
      "Microsoft.CustomerInsights/hubs/connectors/update/action",
      "Microsoft.CustomerInsights/hubs/connectors/activate/action",
      "Microsoft.CustomerInsights/hubs/connectors/activate/action",
      "Microsoft.CustomerInsights/hubs/connectors/getruntimestatus/action",
      "Microsoft.CustomerInsights/hubs/connectors/saveauthinfo/action",
      "Microsoft.CustomerInsights/hubs/connectors/operations/read",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/read",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/write",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/delete",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/activate/action",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/operations/read",
      "Microsoft.CustomerInsights/hubs/interactions/read",
      "Microsoft.CustomerInsights/hubs/interactions/write",
      "Microsoft.CustomerInsights/hubs/interactions/delete",
      "Microsoft.CustomerInsights/hubs/interactions/suggestrelationshiplinks/action",
      "Microsoft.CustomerInsights/hubs/interactions/operations/read",
      "Microsoft.CustomerInsights/hubs/profiles/read",
      "Microsoft.CustomerInsights/hubs/profiles/write",
      "Microsoft.CustomerInsights/hubs/profiles/delete",
      "Microsoft.CustomerInsights/hubs/profiles/operations/read",
      "Microsoft.CustomerInsights/hubs/kpi/read",
      "Microsoft.CustomerInsights/hubs/kpi/write",
      "Microsoft.CustomerInsights/hubs/kpi/delete",
      "Microsoft.CustomerInsights/hubs/kpi/reprocess/action",
      "Microsoft.CustomerInsights/hubs/kpi/operations/read",
      "Microsoft.CustomerInsights/hubs/roleAssignments/read",
      "Microsoft.CustomerInsights/hubs/roleAssignments/write",
      "Microsoft.CustomerInsights/hubs/roleAssignments/delete",
      "Microsoft.CustomerInsights/hubs/roleAssignments/operations/read",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/read",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/write",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/delete",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/regeneratePrimaryKey/action",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/regenerateSecondaryKey/action",
      "Microsoft.CustomerInsights/hubs/segments/read",
      "Microsoft.CustomerInsights/hubs/segments/write",
      "Microsoft.CustomerInsights/hubs/segments/delete",
      "Microsoft.CustomerInsights/hubs/segments/dynamic/action",
      "Microsoft.CustomerInsights/hubs/segments/static/action",
      "Microsoft.CustomerInsights/hubs/roles/read",
      "Microsoft.CustomerInsights/hubs/predictivematchpolicies/read",
      "Microsoft.CustomerInsights/hubs/predictivematchpolicies/write",
      "Microsoft.CustomerInsights/hubs/predictivematchpolicies/delete",
      "Microsoft.CustomerInsights/hubs/predictivematchpolicies/operations/read",
      "Microsoft.CustomerInsights/hubs/predictions/read",
      "Microsoft.CustomerInsights/hubs/predictions/write",
      "Microsoft.CustomerInsights/hubs/predictions/delete",
      "Microsoft.CustomerInsights/hubs/predictions/operations/read",
      "Microsoft.CustomerInsights/hubs/links/read",
      "Microsoft.CustomerInsights/hubs/links/write",
      "Microsoft.CustomerInsights/hubs/links/delete",
      "Microsoft.CustomerInsights/hubs/links/operations/read",
      "Microsoft.CustomerInsights/hubs/relationships/read",
      "Microsoft.CustomerInsights/hubs/relationships/write",
      "Microsoft.CustomerInsights/hubs/relationships/delete",
      "Microsoft.CustomerInsights/hubs/relationships/operations/read",
      "Microsoft.CustomerInsights/hubs/relationshiplinks/read",
      "Microsoft.CustomerInsights/hubs/relationshiplinks/write",
      "Microsoft.CustomerInsights/hubs/relationshiplinks/delete",
      "Microsoft.CustomerInsights/hubs/relationshiplinks/operations/read",
      "Microsoft.CustomerInsights/hubs/gdpr/read",
      "Microsoft.CustomerInsights/hubs/gdpr/write",
      "Microsoft.CustomerInsights/hubs/gdpr/delete",
      "Microsoft.CustomerInsights/hubs/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.CustomerInsights/hubs/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.CustomerInsights/hubs/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.CustomerInsights/hubs/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.CustomerInsights/hubs/sqlconnectionstrings/read",
      "Microsoft.CustomerInsights/hubs/sqlconnectionstrings/write",
      "Microsoft.CustomerInsights/hubs/sqlconnectionstrings/delete",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "customer_insights_readonly_definition" {
  name              = "customer-insights-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.CustomerInsights/operations/read",
      "Microsoft.CustomerInsights/hubs/read",
      "Microsoft.CustomerInsights/hubs/operationresults/read",
      "Microsoft.CustomerInsights/hubs/getbillinghistory/read",
      "Microsoft.CustomerInsights/hubs/getbillingcredits/read",
      "Microsoft.CustomerInsights/hubs/tenantmanagement/read",
      "Microsoft.CustomerInsights/hubs/views/read",
      "Microsoft.CustomerInsights/hubs/images/read",
      "Microsoft.CustomerInsights/hubs/widgettypes/read",
      "Microsoft.CustomerInsights/hubs/crmmetadata/read",
      "Microsoft.CustomerInsights/hubs/adobemetadata/read",
      "Microsoft.CustomerInsights/hubs/salesforcemetadata/read",
      "Microsoft.CustomerInsights/hubs/msemetadata/read",
      "Microsoft.CustomerInsights/hubs/connectors/read",
      "Microsoft.CustomerInsights/hubs/connectors/operations/read",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/read",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/operations/read",
      "Microsoft.CustomerInsights/hubs/interactions/read",
      "Microsoft.CustomerInsights/hubs/interactions/operations/read",
      "Microsoft.CustomerInsights/hubs/profiles/read",
      "Microsoft.CustomerInsights/hubs/profiles/operations/read",
      "Microsoft.CustomerInsights/hubs/kpi/read",
      "Microsoft.CustomerInsights/hubs/kpi/operations/read",
      "Microsoft.CustomerInsights/hubs/roleAssignments/read",
      "Microsoft.CustomerInsights/hubs/roleAssignments/operations/read",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/read",
      "Microsoft.CustomerInsights/hubs/segments/read",
      "Microsoft.CustomerInsights/hubs/roles/read",
      "Microsoft.CustomerInsights/hubs/predictivematchpolicies/read",
      "Microsoft.CustomerInsights/hubs/predictivematchpolicies/operations/read",
      "Microsoft.CustomerInsights/hubs/predictions/read",
      "Microsoft.CustomerInsights/hubs/predictions/operations/read",
      "Microsoft.CustomerInsights/hubs/links/read",
      "Microsoft.CustomerInsights/hubs/links/operations/read",
      "Microsoft.CustomerInsights/hubs/relationships/read",
      "Microsoft.CustomerInsights/hubs/relationships/operations/read",
      "Microsoft.CustomerInsights/hubs/relationshiplinks/read",
      "Microsoft.CustomerInsights/hubs/relationshiplinks/operations/read",
      "Microsoft.CustomerInsights/hubs/gdpr/read",
      "Microsoft.CustomerInsights/hubs/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.CustomerInsights/hubs/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.CustomerInsights/hubs/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.CustomerInsights/hubs/sqlconnectionstrings/read",
    ]

    not_actions = [
      "Microsoft.CustomerInsights/register/action",
      "Microsoft.CustomerInsights/unregister/action",
      "Microsoft.CustomerInsights/hubs/write",
      "Microsoft.CustomerInsights/hubs/delete",
      "Microsoft.CustomerInsights/hubs/suggesttypeschema/action",
      "Microsoft.CustomerInsights/hubs/crmmetadata/action",
      "Microsoft.CustomerInsights/hubs/adobemetadata/action",
      "Microsoft.CustomerInsights/hubs/salesforcemetadata/action",
      "Microsoft.CustomerInsights/hubs/msemetadata/action",
      "Microsoft.CustomerInsights/hubs/views/write",
      "Microsoft.CustomerInsights/hubs/views/delete",
      "Microsoft.CustomerInsights/hubs/images/write",
      "Microsoft.CustomerInsights/hubs/images/delete",
      "Microsoft.CustomerInsights/hubs/connectors/write",
      "Microsoft.CustomerInsights/hubs/connectors/delete",
      "Microsoft.CustomerInsights/hubs/connectors/update/action",
      "Microsoft.CustomerInsights/hubs/connectors/activate/action",
      "Microsoft.CustomerInsights/hubs/connectors/activate/action",
      "Microsoft.CustomerInsights/hubs/connectors/getruntimestatus/action",
      "Microsoft.CustomerInsights/hubs/connectors/saveauthinfo/action",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/write",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/delete",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/activate/action",
      "Microsoft.CustomerInsights/hubs/interactions/write",
      "Microsoft.CustomerInsights/hubs/interactions/delete",
      "Microsoft.CustomerInsights/hubs/interactions/suggestrelationshiplinks/action",
      "Microsoft.CustomerInsights/hubs/profiles/write",
      "Microsoft.CustomerInsights/hubs/profiles/delete",
      "Microsoft.CustomerInsights/hubs/kpi/write",
      "Microsoft.CustomerInsights/hubs/kpi/delete",
      "Microsoft.CustomerInsights/hubs/kpi/reprocess/action",
      "Microsoft.CustomerInsights/hubs/roleAssignments/write",
      "Microsoft.CustomerInsights/hubs/roleAssignments/delete",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/write",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/delete",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/regeneratePrimaryKey/action",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/regenerateSecondaryKey/action",
      "Microsoft.CustomerInsights/hubs/segments/write",
      "Microsoft.CustomerInsights/hubs/segments/delete",
      "Microsoft.CustomerInsights/hubs/segments/dynamic/action",
      "Microsoft.CustomerInsights/hubs/segments/static/action",
      "Microsoft.CustomerInsights/hubs/predictivematchpolicies/write",
      "Microsoft.CustomerInsights/hubs/predictivematchpolicies/delete",
      "Microsoft.CustomerInsights/hubs/predictions/write",
      "Microsoft.CustomerInsights/hubs/predictions/delete",
      "Microsoft.CustomerInsights/hubs/links/write",
      "Microsoft.CustomerInsights/hubs/links/delete",
      "Microsoft.CustomerInsights/hubs/relationships/write",
      "Microsoft.CustomerInsights/hubs/relationships/delete",
      "Microsoft.CustomerInsights/hubs/relationshiplinks/write",
      "Microsoft.CustomerInsights/hubs/relationshiplinks/delete",
      "Microsoft.CustomerInsights/hubs/gdpr/write",
      "Microsoft.CustomerInsights/hubs/gdpr/delete",
      "Microsoft.CustomerInsights/hubs/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.CustomerInsights/hubs/sqlconnectionstrings/write",
      "Microsoft.CustomerInsights/hubs/sqlconnectionstrings/delete",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "customer_insights_noaccess_definition" {
  name              = "customer-insights-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.CustomerInsights/register/action",
      "Microsoft.CustomerInsights/unregister/action",
      "Microsoft.CustomerInsights/operations/read",
      "Microsoft.CustomerInsights/hubs/read",
      "Microsoft.CustomerInsights/hubs/write",
      "Microsoft.CustomerInsights/hubs/delete",
      "Microsoft.CustomerInsights/hubs/suggesttypeschema/action",
      "Microsoft.CustomerInsights/hubs/crmmetadata/action",
      "Microsoft.CustomerInsights/hubs/adobemetadata/action",
      "Microsoft.CustomerInsights/hubs/salesforcemetadata/action",
      "Microsoft.CustomerInsights/hubs/msemetadata/action",
      "Microsoft.CustomerInsights/hubs/operationresults/read",
      "Microsoft.CustomerInsights/hubs/getbillinghistory/read",
      "Microsoft.CustomerInsights/hubs/getbillingcredits/read",
      "Microsoft.CustomerInsights/hubs/tenantmanagement/read",
      "Microsoft.CustomerInsights/hubs/views/read",
      "Microsoft.CustomerInsights/hubs/views/write",
      "Microsoft.CustomerInsights/hubs/views/delete",
      "Microsoft.CustomerInsights/hubs/images/read",
      "Microsoft.CustomerInsights/hubs/images/write",
      "Microsoft.CustomerInsights/hubs/images/delete",
      "Microsoft.CustomerInsights/hubs/widgettypes/read",
      "Microsoft.CustomerInsights/hubs/crmmetadata/read",
      "Microsoft.CustomerInsights/hubs/adobemetadata/read",
      "Microsoft.CustomerInsights/hubs/salesforcemetadata/read",
      "Microsoft.CustomerInsights/hubs/msemetadata/read",
      "Microsoft.CustomerInsights/hubs/connectors/read",
      "Microsoft.CustomerInsights/hubs/connectors/write",
      "Microsoft.CustomerInsights/hubs/connectors/delete",
      "Microsoft.CustomerInsights/hubs/connectors/update/action",
      "Microsoft.CustomerInsights/hubs/connectors/activate/action",
      "Microsoft.CustomerInsights/hubs/connectors/activate/action",
      "Microsoft.CustomerInsights/hubs/connectors/getruntimestatus/action",
      "Microsoft.CustomerInsights/hubs/connectors/saveauthinfo/action",
      "Microsoft.CustomerInsights/hubs/connectors/operations/read",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/read",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/write",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/delete",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/activate/action",
      "Microsoft.CustomerInsights/hubs/connectors/mappings/operations/read",
      "Microsoft.CustomerInsights/hubs/interactions/read",
      "Microsoft.CustomerInsights/hubs/interactions/write",
      "Microsoft.CustomerInsights/hubs/interactions/delete",
      "Microsoft.CustomerInsights/hubs/interactions/suggestrelationshiplinks/action",
      "Microsoft.CustomerInsights/hubs/interactions/operations/read",
      "Microsoft.CustomerInsights/hubs/profiles/read",
      "Microsoft.CustomerInsights/hubs/profiles/write",
      "Microsoft.CustomerInsights/hubs/profiles/delete",
      "Microsoft.CustomerInsights/hubs/profiles/operations/read",
      "Microsoft.CustomerInsights/hubs/kpi/read",
      "Microsoft.CustomerInsights/hubs/kpi/write",
      "Microsoft.CustomerInsights/hubs/kpi/delete",
      "Microsoft.CustomerInsights/hubs/kpi/reprocess/action",
      "Microsoft.CustomerInsights/hubs/kpi/operations/read",
      "Microsoft.CustomerInsights/hubs/roleAssignments/read",
      "Microsoft.CustomerInsights/hubs/roleAssignments/write",
      "Microsoft.CustomerInsights/hubs/roleAssignments/delete",
      "Microsoft.CustomerInsights/hubs/roleAssignments/operations/read",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/read",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/write",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/delete",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/regeneratePrimaryKey/action",
      "Microsoft.CustomerInsights/hubs/authorizationPolicies/regenerateSecondaryKey/action",
      "Microsoft.CustomerInsights/hubs/segments/read",
      "Microsoft.CustomerInsights/hubs/segments/write",
      "Microsoft.CustomerInsights/hubs/segments/delete",
      "Microsoft.CustomerInsights/hubs/segments/dynamic/action",
      "Microsoft.CustomerInsights/hubs/segments/static/action",
      "Microsoft.CustomerInsights/hubs/roles/read",
      "Microsoft.CustomerInsights/hubs/predictivematchpolicies/read",
      "Microsoft.CustomerInsights/hubs/predictivematchpolicies/write",
      "Microsoft.CustomerInsights/hubs/predictivematchpolicies/delete",
      "Microsoft.CustomerInsights/hubs/predictivematchpolicies/operations/read",
      "Microsoft.CustomerInsights/hubs/predictions/read",
      "Microsoft.CustomerInsights/hubs/predictions/write",
      "Microsoft.CustomerInsights/hubs/predictions/delete",
      "Microsoft.CustomerInsights/hubs/predictions/operations/read",
      "Microsoft.CustomerInsights/hubs/links/read",
      "Microsoft.CustomerInsights/hubs/links/write",
      "Microsoft.CustomerInsights/hubs/links/delete",
      "Microsoft.CustomerInsights/hubs/links/operations/read",
      "Microsoft.CustomerInsights/hubs/relationships/read",
      "Microsoft.CustomerInsights/hubs/relationships/write",
      "Microsoft.CustomerInsights/hubs/relationships/delete",
      "Microsoft.CustomerInsights/hubs/relationships/operations/read",
      "Microsoft.CustomerInsights/hubs/relationshiplinks/read",
      "Microsoft.CustomerInsights/hubs/relationshiplinks/write",
      "Microsoft.CustomerInsights/hubs/relationshiplinks/delete",
      "Microsoft.CustomerInsights/hubs/relationshiplinks/operations/read",
      "Microsoft.CustomerInsights/hubs/gdpr/read",
      "Microsoft.CustomerInsights/hubs/gdpr/write",
      "Microsoft.CustomerInsights/hubs/gdpr/delete",
      "Microsoft.CustomerInsights/hubs/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.CustomerInsights/hubs/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.CustomerInsights/hubs/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.CustomerInsights/hubs/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.CustomerInsights/hubs/sqlconnectionstrings/read",
      "Microsoft.CustomerInsights/hubs/sqlconnectionstrings/write",
      "Microsoft.CustomerInsights/hubs/sqlconnectionstrings/delete",
    ]
  }
}
